package envoy.client.ui.list;

import javax.swing.JComponent;

/**
 * Handles the selection of elements in a {@link ComponentList}.<br>
 * <br>
 * Project: <strong>envoy-client</strong>
 * File: <strong>SelectionHandler.java</strong>
 * Created: <strong>21.03.2020</strong>
 *
 * @author Kai S. K. Engelbart
 * @param <E> the type of the underlying {@link ComponentList}
 * @since Envoy Client v0.1-beta
 */
@FunctionalInterface
public interface SelectionHandler<E> {

	/**
	 * Notifies the handler about a selection.
	 *
	 * @param element    the selected element
	 * @param component  the selected component
	 * @param isSelected contains the selection state
	 * @since Envoy Client v0.1-beta
	 */
	void selectionChanged(E element, JComponent component, boolean isSelected);
}
